.386
.model flat, stdcall
option casemap:none

include         \masm32\include\windows.inc

GetProcAddress  PROTO :DWORD,:DWORD
LoadLibraryA    PROTO :DWORD
LoadLibrary EQU <LoadLibraryA>

VirtualAlloc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
MemCopy         PROTO :DWORD,:DWORD,:DWORD

.code

LoadEXEfromMem PROC uses esi edi ebx pEXE:DWORD,pEntryPoint:DWORD

LOCAL hVirtModule:DWORD     ; handle to virtual module
LOCAL impsec:DWORD          ; adress of import section
LOCAL relocsec:DWORD        ; adress of relocation section
LOCAL delta:DWORD           ; image base - virtual image base for relocations
LOCAL hLib:DWORD            ; handle to DLLs

    xor     eax,eax
    mov     esi,pEXE
    cmp     IMAGE_DOS_HEADER.e_magic[esi],IMAGE_DOS_SIGNATURE
    jne     finish
    add     esi,IMAGE_DOS_HEADER.e_lfanew[esi]
    cmp     IMAGE_NT_HEADERS.Signature[esi],IMAGE_NT_SIGNATURE
    jne     finish
    mov     edx,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[1*8][esi]    ; get the RVA of the import section
    mov     impsec,edx
    mov     edx,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[5*8][esi]    ; get the RVA of the relocation section
    mov     relocsec,edx
    movzx   ebx,IMAGE_NT_HEADERS.FileHeader.NumberOfSections[esi]
    mov     eax,IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage[esi]          ; get the size of image
    add     eax,4
    invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE         ; allocate memory to copy all the sections
    test    eax,eax
    jz      finish                             ; exit if no memory allocation
    mov     hVirtModule,eax                        ; get the handle of the virtual module
    mov     edx,IMAGE_NT_HEADERS.OptionalHeader.ImageBase[esi]          ; get the image base of the module
    sub     edx,eax
    mov     delta,edx                         ; calculate the deviation to fix the relocations
    add     eax,IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint[esi]
    mov     edx,pEntryPoint
    mov     DWORD PTR [edx],eax                    ; get the entry point of the virtual module
    mov     edi,pEXE
    invoke  MemCopy,edi,hVirtModule,IMAGE_NT_HEADERS.OptionalHeader.SizeOfHeaders[esi]
    add     edi,IMAGE_NT_HEADERS.OptionalHeader.SizeOfHeaders[esi]         ; points the first section
    add     esi,SIZEOF(IMAGE_NT_HEADERS)                   ; points the section table
@@:
    mov     edx,hVirtModule
    add     edx,IMAGE_SECTION_HEADER.VirtualAddress[esi]              ; get the address of the current section
    push    edx
    invoke  MemCopy,edi,edx,IMAGE_SECTION_HEADER.SizeOfRawData[esi]         ; copy the section
    pop     edx
    add     edi,IMAGE_SECTION_HEADER.SizeOfRawData[esi]
    add     esi,SIZEOF(IMAGE_SECTION_HEADER)
    dec     ebx
    jnz     @b

    mov     edi,hVirtModule
    add     edi,impsec                         ; points the import section
    sub     edi,SIZEOF(IMAGE_IMPORT_DESCRIPTOR)

restart:

    add     edi,SIZEOF(IMAGE_IMPORT_DESCRIPTOR)
    cmp     IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk[edi],0          ; is it the end of the import section?
    jne     @f
    cmp     IMAGE_IMPORT_DESCRIPTOR.TimeDateStamp[edi],0
    jne     @f
    cmp     IMAGE_IMPORT_DESCRIPTOR.ForwarderChain[edi],0
    jne     @f
    cmp     IMAGE_IMPORT_DESCRIPTOR.Name1[edi],0
    jne     @f
    cmp     IMAGE_IMPORT_DESCRIPTOR.FirstThunk[edi],0
    jz      reloc_sect                         ; jump to fix the relocations
@@:
    mov     edx,IMAGE_IMPORT_DESCRIPTOR.Name1[edi]
    add     edx,hVirtModule
    invoke  LoadLibrary,edx                        ; load the DLL from which the funcs are imported
    mov     hLib,eax
    mov     esi,IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk[edi]
    add     esi,hVirtModule
    mov     ebx,IMAGE_IMPORT_DESCRIPTOR.FirstThunk[edi]
    add     ebx,hVirtModule
@@:
    mov     eax,IMAGE_THUNK_DATA.u1.Function[esi]
    test    eax,eax
    jz      restart
    add     eax,hVirtModule
    invoke  GetProcAddress,hLib,ADDR IMAGE_IMPORT_BY_NAME.Name1[eax]         ; get the adress of the imported function
    mov     DWORD PTR [ebx],eax
    add     esi,SIZEOF(IMAGE_THUNK_DATA)
    add     ebx,SIZEOF(IMAGE_THUNK_DATA)
    jmp     @b

reloc_sect:

    mov     edi,relocsec
    add     edi,hVirtModule                        ; points the relocation section

reloc_block:

    mov     esi,IMAGE_BASE_RELOCATION.VirtualAddress[edi]              ; is it the end of the relocation section?
    test    esi,esi
    jz      end_of_reloc
    mov     ebx,IMAGE_BASE_RELOCATION.SizeOfBlock[edi]              ; get the size of the relocation data block
    sub     ebx,8
    add     edi,SIZEOF(IMAGE_BASE_RELOCATION)               ; skip the IMAGE_BASE_RELOCATION header

process_reloc:

    movzx   eax,WORD PTR [edi]
    mov     ecx,eax
    shr     ax,12
    test    eax,eax
    jz      @f
    and     ecx,0FFFh
    add     ecx,esi
    add     ecx,hVirtModule
    mov     eax,DWORD PTR [ecx]
    sub     eax,delta
    mov     DWORD PTR [ecx],eax
@@:
    add     edi,2
    sub     ebx,2
    jnz     process_reloc
    jmp     reloc_block

end_of_reloc:

    mov     eax,hVirtModule                        ; return the handle to the virtual module

finish:

    ret

LoadEXEfromMem ENDP    

END

